UPLOADER?=nodemcu-uploader
PORT?=/dev/ttyUSB0
LUAC=luac.cross

l?=luac.out

help:
	@echo "make upload f=filename"
	@echo "make remove f=filename"
	@echo "make remove-run.lua f=file.lua"
	@echo "make cross f=file.lua l=file.lc"
	@echo "make download f=filename"
	@echo "make backup d=dir"
	@echo "make run"
	@echo "make t"

t:terminal

terminal:
	echo "terminal exit ^]"
	$(UPLOADER) terminal

upload:
	@echo "Upload "$f" file"
	$(UPLOADER) upload $f

remove:
	@echo "Remove "$f" file"
	echo "file.remove(\"$f\")\r\n" > $(PORT)

remove-run.lua:
	echo "file.remove(\"run.lua\")\r\n" > $(PORT)

run:
	cp $f run.lua
	$(UPLOADER) upload run.lua

download:
	mkdir -p download
	$(UPLOADER) download $f out
	mv out download/$f
	cat download/$f

backup:
	@echo "Haciendo backup"
	rm -rf $d
	$(UPLOADER) backup $d

cross:
	@echo "Cross-compile "$f" file"
	$(LUAC) -o $l $f
	# $(LUAC) -o ($f | sed 's/.lua/.lc/') $f

sniff:
	jpnevulator --ascii --timing-print --tty $(PORT):nodemcu --read

clean:
	@echo "Removiendo archivos .lc y *.out si estos existen en el directorio actual."
	rm -rf *.lc *.out

.PHONY: upload download
